/*
    This Software (C) Copyright David Goodwin, 2007, 2008.
    
     This is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This software is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this software; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * LTSTransition.java
 *
 * Created on 24 July 2007, 21:02
 */

package assignment;

/**
 *
 * @author David
 */
public class LTSTransition {
    protected LTSNode node1;
    protected LTSNode node2;
    protected String name;
    
    /** Creates a new instance of LTSTransition */
    public LTSTransition() {

    }
    
    public LTSTransition(LTSNode _node1, LTSNode _node2, String name) {
        setName(name);
        setNode1(_node1);
        setNode2(_node2);
    }
    
    public String getName() {
        return name;
    }
    
    public void setName(String theName) {
        name = theName;
    }
    
    public LTSNode getNode1() {
        return node1;
    }
    public LTSNode getNode2() {
        return node2;
    }

    public void setNode1(LTSNode theNode){
        node1 = theNode;
    }
    
    public void setNode2(LTSNode theNode) {
        node2 = theNode;
    }
    
    public boolean equals(LTSTransition ltst) {
        if (ltst.getNode1().getName().equals(node1.getName())
            && ltst.getNode2().getName().equals(node2.getName())
            && ltst.getName().equals(name))
            return true;
        else
            return false;
    }
    
    public boolean equals(Object o) {
        try {
            LTSTransition ltst = (LTSTransition) o;
            return equals(ltst);
        }
        catch (Exception e) {
            return false;
        }
    }
    
    public int hashCode() {
        return toString().hashCode();
    }
    
    public String toString() {
        if ((name == "") && (node2 == null))
            return node1.toString();
        else {
            String n1 = node1.toString();
            String n2 = node2.toString();
            
            if (n1.contains(" ") || n1.contains("-") ||
                    n1.contains("|") || n1.contains("=")) {
                n1 = "\"" + n1 + "\"";
            }
            
            if (n2.contains(" ") || n2.contains("-") ||
                    n2.contains("|") || n2.contains("=")) {
                n2 = "\"" + n2 + "\"";
            }            
            
            return n1 + "/" + name + "/" + n2;
        }
        
    }
    
}
